'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderRoute = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/**
 * Render route into JS.
 */

var renderRoute = exports.renderRoute = function () {
  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(route, options) {
    var _options$publicPath, publicPath, node;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            (0, _bluebird.promisifyAll)(options.fs);
            _options$publicPath = options.publicPath;
            publicPath = _options$publicPath === undefined ? '/' : _options$publicPath;
            _context.next = 5;
            return renderRoutePage(route, publicPath, [''], options);

          case 5:
            node = _context.sent;
            return _context.abrupt('return', node);

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return function renderRoute(_x, _x2) {
    return ref.apply(this, arguments);
  };
}();

var renderRoutePage = function () {
  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(route, path, trace, options) {
    var indexRoute, childRoutes, key, getComponent, _getComponent;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!route.route) {
              _context2.next = 23;
              break;
            }

            indexRoute = void 0;
            childRoutes = [];
            _context2.t0 = _regenerator2.default.keys(route.route);

          case 4:
            if ((_context2.t1 = _context2.t0()).done) {
              _context2.next = 19;
              break;
            }

            key = _context2.t1.value;

            if (!(key === 'index')) {
              _context2.next = 12;
              break;
            }

            _context2.next = 9;
            return renderRoutePage(route.route[key], null, trace, options);

          case 9:
            indexRoute = _context2.sent;
            _context2.next = 17;
            break;

          case 12:
            _context2.t2 = childRoutes;
            _context2.next = 15;
            return renderRoutePage(route.route[key], key, trace.concat(key), options);

          case 15:
            _context2.t3 = _context2.sent;

            _context2.t2.push.call(_context2.t2, _context2.t3);

          case 17:
            _context2.next = 4;
            break;

          case 19:
            getComponent = renderGetComponent(route.page, {
              split: options.split !== undefined ? options.split : route.split,
              chunkName: trace.join('/')
            });
            return _context2.abrupt('return', renderRouteSpec({
              path: path,
              getComponent: getComponent,
              indexRoute: indexRoute,
              childRoutes: childRoutes
            }));

          case 23:
            if (!route.collection) {
              _context2.next = 27;
              break;
            }

            return _context2.abrupt('return', renderRouteCollection(route, path, trace, options));

          case 27:
            _getComponent = renderGetComponent(route.page, {
              split: options.split !== undefined ? options.split : route.split,
              chunkName: trace.join('/')
            });
            return _context2.abrupt('return', renderRouteSpec({
              path: path,
              getComponent: _getComponent
            }));

          case 29:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return function renderRoutePage(_x3, _x4, _x5, _x6) {
    return ref.apply(this, arguments);
  };
}();

var renderRouteCollection = function () {
  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(route, path, trace, options) {
    var _route$collection, _route$collection$pag, directory, match, paginate, chunkName, name, items, chunks, childRoutes, getComponent, pageParam;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _route$collection = route.collection;
            _route$collection$pag = _route$collection.page;
            directory = _route$collection$pag.directory;
            match = _route$collection$pag.match;
            paginate = _route$collection.paginate;
            chunkName = trace.join('/');
            name = chunkName;
            _context3.next = 9;
            return walkDirectory(options.fs, directory);

          case 9:
            _context3.t0 = function (filename) {
              return match(filename);
            };

            _context3.t1 = function (filename) {
              return {
                filename: filename,
                path: stripExtension((0, _path.relative)(directory, filename))
              };
            };

            items = _context3.sent.filter(_context3.t0).map(_context3.t1);
            chunks = [items];

            if (paginate) {
              chunks = (0, _lodash.chunk)(items, paginate.size);
            }

            chunks = chunks.map(function (chunk, idx) {
              return renderGetCollectionChunk(chunk, {
                page: route.page,
                chunkNumber: idx,
                chunkCount: chunks.length,
                loader: META_LOADER,
                chunkName: trace.concat('@page', idx + 1).join('/'),
                split: options.split !== undefined ? options.split : true
              });
            });

            childRoutes = items.map(function (item) {
              return renderRouteSpec({
                path: item.path,
                getComponent: renderGetComponent(item.filename, {
                  split: options.split !== undefined ? options.split : true,
                  chunkName: trace.concat(item.path).join('/')
                })
              });
            });

            getComponent = function (_param) {
              return {
                "type": "FunctionExpression",
                "id": {
                  "type": "Identifier",
                  "name": "getComponent"
                },
                "generator": false,
                "expression": false,
                "async": false,
                "params": [{
                  "type": "Identifier",
                  "name": "nextState"
                }, {
                  "type": "Identifier",
                  "name": "cb"
                }],
                "body": {
                  "type": "BlockStatement",
                  "body": [{
                    "type": "VariableDeclaration",
                    "declarations": [{
                      "type": "VariableDeclarator",
                      "id": {
                        "type": "Identifier",
                        "name": "pageNumber"
                      },
                      "init": {
                        "type": "CallExpression",
                        "callee": {
                          "type": "Identifier",
                          "name": "parseInt"
                        },
                        "arguments": [{
                          "type": "LogicalExpression",
                          "left": {
                            "type": "MemberExpression",
                            "object": {
                              "type": "MemberExpression",
                              "object": {
                                "type": "Identifier",
                                "name": "nextState"
                              },
                              "property": {
                                "type": "Identifier",
                                "name": "params"
                              },
                              "computed": false
                            },
                            "property": {
                              "type": "Identifier",
                              "name": "page"
                            },
                            "computed": false
                          },
                          "operator": "||",
                          "right": {
                            "type": "NumericLiteral",
                            "extra": {
                              "rawValue": 1,
                              "raw": "1"
                            },
                            "value": 1
                          }
                        }, {
                          "type": "NumericLiteral",
                          "extra": {
                            "rawValue": 10,
                            "raw": "10"
                          },
                          "value": 10
                        }]
                      }
                    }],
                    "kind": "var"
                  }, {
                    "type": "VariableDeclaration",
                    "declarations": [{
                      "type": "VariableDeclarator",
                      "id": {
                        "type": "Identifier",
                        "name": "chunkList"
                      },
                      "init": _param
                    }],
                    "kind": "var"
                  }, {
                    "type": "VariableDeclaration",
                    "declarations": [{
                      "type": "VariableDeclarator",
                      "id": {
                        "type": "Identifier",
                        "name": "getCollectionChunk"
                      },
                      "init": {
                        "type": "MemberExpression",
                        "object": {
                          "type": "Identifier",
                          "name": "chunkList"
                        },
                        "property": {
                          "type": "BinaryExpression",
                          "left": {
                            "type": "Identifier",
                            "name": "pageNumber"
                          },
                          "operator": "-",
                          "right": {
                            "type": "NumericLiteral",
                            "extra": {
                              "rawValue": 1,
                              "raw": "1"
                            },
                            "value": 1
                          }
                        },
                        "computed": true
                      }
                    }],
                    "kind": "var"
                  }, {
                    "type": "ExpressionStatement",
                    "expression": {
                      "type": "CallExpression",
                      "callee": {
                        "type": "Identifier",
                        "name": "getCollectionChunk"
                      },
                      "arguments": [{
                        "type": "Identifier",
                        "name": "nextState"
                      }, {
                        "type": "Identifier",
                        "name": "cb"
                      }]
                    }
                  }],
                  "directives": []
                },
                "extra": {
                  "parenthesized": true,
                  "parenStart": 0
                }
              };
            }(types.arrayExpression(chunks));

            pageParam = types.arrayExpression(chunks.map(function (_, idx) {
              return types.numericLiteral(idx + 1);
            }));

            childRoutes = childRoutes.concat(renderRouteSpec({
              path: '@page/:page',
              name: name,
              params: function (_param2) {
                return {
                  "type": "ObjectExpression",
                  "properties": [{
                    "type": "ObjectProperty",
                    "method": false,
                    "shorthand": false,
                    "computed": false,
                    "key": {
                      "type": "Identifier",
                      "name": "page"
                    },
                    "value": _param2
                  }],
                  "extra": {
                    "parenthesized": true,
                    "parenStart": 0
                  }
                };
              }(pageParam)
            }));

            return _context3.abrupt('return', renderRouteSpec({
              path: path,
              getComponent: getComponent,
              childRoutes: childRoutes,
              name: name
            }));

          case 20:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));
  return function renderRouteCollection(_x7, _x8, _x9, _x10) {
    return ref.apply(this, arguments);
  };
}();

/**
 * Render a fetcher for a collection chunk.
 */


var walkDirectory = function () {
  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(fs, directory) {
    var _this = this;

    var files;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return fs.readdirAsync(directory).then(function (segments) {
              return _promise2.default.all(segments.map(function () {
                var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(segment) {
                  var filename, stat;
                  return _regenerator2.default.wrap(function _callee4$(_context4) {
                    while (1) {
                      switch (_context4.prev = _context4.next) {
                        case 0:
                          filename = (0, _path.join)(directory, segment);
                          _context4.next = 3;
                          return fs.statAsync(filename);

                        case 3:
                          stat = _context4.sent;

                          if (!stat.isDirectory()) {
                            _context4.next = 8;
                            break;
                          }

                          return _context4.abrupt('return', walkDirectory(fs, filename));

                        case 8:
                          return _context4.abrupt('return', [filename]);

                        case 9:
                        case 'end':
                          return _context4.stop();
                      }
                    }
                  }, _callee4, _this);
                }));
                return function (_x13) {
                  return ref.apply(this, arguments);
                };
              }()));
            });

          case 2:
            files = _context5.sent;
            return _context5.abrupt('return', (0, _lodash.flatten)(files));

          case 4:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));
  return function walkDirectory(_x11, _x12) {
    return ref.apply(this, arguments);
  };
}();

exports.forEach = forEach;
exports.validate = validate;
exports.forEachPath = forEachPath;

var _path = require('path');

var _bluebird = require('bluebird');

var _minimatch = require('minimatch');

var _minimatch2 = _interopRequireDefault(_minimatch);

var _lodash = require('lodash');

var _schema = require('validated/schema');

var _object = require('validated/object');

var _babelTypes = require('babel-types');

var types = _interopRequireWildcard(_babelTypes);

var _config = require('./config');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright 2016-present, Sitegen team
 */

var META_LOADER = require.resolve('./loader/meta');
var CHUNK_LOADER = require.resolve('./loader/chunk');
var REACT_HOT_LOADER = require.resolve('react-hot-loader/webpack');

function forEach(route, func) {
  func(route);
  if (route.route) {
    for (var k in route.route) {
      forEach(route.route[k], func);
    }
  }
}

/**
 * Validate route.
 */
function validate(route, _ref) {
  var basedir = _ref.basedir;

  var pattern = _schema.string.andThen(function (val) {
    return parsePattern(val, { basedir: basedir });
  });
  var pageShortcut = _schema.string.andThen(function (page) {
    return { page: page };
  });
  var collectionShortcut = pattern.andThen(function (page) {
    return { page: page };
  });
  var schema = (0, _schema.ref)();

  var routePage = (0, _schema.oneOf)(pageShortcut, (0, _schema.object)({
    page: _schema.string,
    split: (0, _schema.maybe)(_schema.boolean),
    route: (0, _schema.maybe)((0, _schema.mapping)(schema)),
    collection: (0, _schema.maybe)((0, _schema.oneOf)(collectionShortcut, (0, _schema.object)({
      page: pattern,
      paginate: (0, _schema.maybe)((0, _schema.object)({ size: _schema.number }))
    })))
  })).andThen(function (route, error) {
    if (route.route && route.collection) {
      error('Route cannot have both "route" and "collection" defined');
    }
    return route;
  });

  schema.set(routePage);

  return (0, _object.validate)(schema, route);
}function renderGetCollectionChunk(chunk, options) {
  options = (0, _extends3.default)({
    loader: META_LOADER,
    chunkName: 'collectionPage',
    split: false
  }, options);

  var query = {
    chunk: chunk,
    loader: options.loader,
    chunkNumber: options.chunkNumber,
    chunkCount: options.chunkCount
  };

  var req = (0, _config.moduleRequest)(options.page, { loader: CHUNK_LOADER, query: query },
  // TODO: we don't really want to leak configuration here, think of a better
  // way to inject this
  REACT_HOT_LOADER);
  return renderGetComponent(req, {
    split: options.split,
    chunkName: options.chunkName
  });
}

/**
 * Render React Router route spec.
 */
function renderRouteSpec(_ref2) {
  var path = _ref2.path;
  var getComponent = _ref2.getComponent;
  var indexRoute = _ref2.indexRoute;
  var childRoutes = _ref2.childRoutes;
  var name = _ref2.name;
  var params = _ref2.params;

  path = path == null ? function () {
    return {
      "type": "Identifier",
      "name": "undefined",
      "extra": {
        "parenthesized": true,
        "parenStart": 0
      }
    };
  }() : types.stringLiteral(path);
  getComponent = getComponent == null ? function () {
    return {
      "type": "Identifier",
      "name": "undefined",
      "extra": {
        "parenthesized": true,
        "parenStart": 0
      }
    };
  }() : getComponent;
  indexRoute = indexRoute == null ? function () {
    return {
      "type": "Identifier",
      "name": "undefined",
      "extra": {
        "parenthesized": true,
        "parenStart": 0
      }
    };
  }() : indexRoute;
  childRoutes = types.arrayExpression(childRoutes || []);
  name = name == null ? function () {
    return {
      "type": "Identifier",
      "name": "undefined",
      "extra": {
        "parenthesized": true,
        "parenStart": 0
      }
    };
  }() : types.stringLiteral(name);
  params = params == null ? function () {
    return {
      "type": "Identifier",
      "name": "undefined",
      "extra": {
        "parenthesized": true,
        "parenStart": 0
      }
    };
  }() : params;
  return function (_param3, _param4, _param5, _param6, _param7, _param8) {
    return {
      "type": "ObjectExpression",
      "properties": [{
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "path"
        },
        "value": _param3
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "getComponent"
        },
        "value": _param4
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "indexRoute"
        },
        "value": _param5
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "childRoutes"
        },
        "value": _param6
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "name"
        },
        "value": _param7
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "params"
        },
        "value": _param8
      }],
      "extra": {
        "parenthesized": true,
        "parenStart": 0
      }
    };
  }(path, getComponent, indexRoute, childRoutes, name, params);
}

/**
 * Render component loader to load component from a given module.
 */
function renderGetComponent(id, options) {
  options = (0, _extends3.default)({
    split: false,
    chunkName: 'component'
  }, options);

  var req = types.stringLiteral(id);

  if (options.split) {
    return function (_param9, _param10) {
      return {
        "type": "FunctionExpression",
        "id": {
          "type": "Identifier",
          "name": "getComponentAsync"
        },
        "generator": false,
        "expression": false,
        "async": false,
        "params": [{
          "type": "Identifier",
          "name": "_nextState"
        }, {
          "type": "Identifier",
          "name": "cb"
        }],
        "body": {
          "type": "BlockStatement",
          "body": [{
            "type": "ExpressionStatement",
            "expression": {
              "type": "CallExpression",
              "callee": {
                "type": "MemberExpression",
                "object": {
                  "type": "Identifier",
                  "name": "require"
                },
                "property": {
                  "type": "Identifier",
                  "name": "ensure"
                },
                "computed": false
              },
              "arguments": [{
                "type": "ArrayExpression",
                "elements": []
              }, {
                "type": "FunctionExpression",
                "id": null,
                "generator": false,
                "expression": false,
                "async": false,
                "params": [{
                  "type": "Identifier",
                  "name": "require"
                }],
                "body": {
                  "type": "BlockStatement",
                  "body": [{
                    "type": "ExpressionStatement",
                    "expression": {
                      "type": "CallExpression",
                      "callee": {
                        "type": "Identifier",
                        "name": "cb"
                      },
                      "arguments": [{
                        "type": "NullLiteral"
                      }, {
                        "type": "MemberExpression",
                        "object": {
                          "type": "CallExpression",
                          "callee": {
                            "type": "Identifier",
                            "name": "require"
                          },
                          "arguments": [_param9]
                        },
                        "property": {
                          "type": "Identifier",
                          "name": "default"
                        },
                        "computed": false
                      }]
                    }
                  }],
                  "directives": []
                }
              }, _param10]
            }
          }],
          "directives": []
        },
        "extra": {
          "parenthesized": true,
          "parenStart": 0
        }
      };
    }(req, types.stringLiteral(options.chunkName));
  } else {
    return function (_param11) {
      return {
        "type": "FunctionExpression",
        "id": {
          "type": "Identifier",
          "name": "getComponentSync"
        },
        "generator": false,
        "expression": false,
        "async": false,
        "params": [{
          "type": "Identifier",
          "name": "_nextState"
        }, {
          "type": "Identifier",
          "name": "cb"
        }],
        "body": {
          "type": "BlockStatement",
          "body": [{
            "type": "ExpressionStatement",
            "expression": {
              "type": "CallExpression",
              "callee": {
                "type": "Identifier",
                "name": "cb"
              },
              "arguments": [{
                "type": "NullLiteral"
              }, {
                "type": "MemberExpression",
                "object": {
                  "type": "CallExpression",
                  "callee": {
                    "type": "Identifier",
                    "name": "require"
                  },
                  "arguments": [_param11]
                },
                "property": {
                  "type": "Identifier",
                  "name": "default"
                },
                "computed": false
              }]
            }
          }],
          "directives": []
        },
        "extra": {
          "parenthesized": true,
          "parenStart": 0
        }
      };
    }(req);
  }
}

function parsePattern(pattern, _ref3) {
  var basedir = _ref3.basedir;

  pattern = (0, _path.join)(basedir, pattern);
  var matcher = new _minimatch2.default.Minimatch(pattern);
  var directory = [];
  for (var i = 0; i < matcher.set[0].length; i++) {
    if (typeof matcher.set[0][i] === 'string') {
      directory.push(matcher.set[0][i]);
    } else {
      break;
    }
  }
  if (directory.length > 1) {
    directory = directory.join('/');
  }
  return {
    directory: directory,
    match: matcher.match.bind(matcher)
  };
}

function stripExtension(filename) {
  return filename.substring(0, filename.length - (0, _path.extname)(filename).length);
}

function forEachPath(route, func) {
  var trace = arguments.length <= 2 || arguments[2] === undefined ? [''] : arguments[2];

  var path = '/' + trace.filter(Boolean).join('/');
  if (route.params) {
    (0, _keys2.default)(route.params).forEach(function (key) {
      route.params[key].forEach(function (value) {
        func(interpolateParams(path, (0, _defineProperty3.default)({}, key, value)));
      });
    });
  } else {
    func(path);
  }
  if (route.childRoutes) {
    route.childRoutes.forEach(function (route) {
      return forEachPath(route, func, trace.concat(route.path));
    });
  }
}

function interpolateParams(path, params) {
  return path.replace(/:([a-zA-Z_\-]+)/g, function (_, key) {
    return params[key];
  });
}
